'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _fileupCore = require('fileup-core');

var _fileupCore2 = _interopRequireDefault(_fileupCore);

var _File = require('fileup-core/lib/models/File');

var _File2 = _interopRequireDefault(_File);

var _QueueCollection = require('fileup-core/lib/models/QueueCollection');

var _QueueCollection2 = _interopRequireDefault(_QueueCollection);

var _actions = require('./actions');

var _fileup = require('./reducers/fileup');

var _FilePropType = require('./types/FilePropType');

var _FilePropType2 = _interopRequireDefault(_FilePropType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function () {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    return function (WrappedComponent) {
        var FileUpHOC = function (_React$Component) {
            _inherits(FileUpHOC, _React$Component);

            function FileUpHOC() {
                _classCallCheck(this, FileUpHOC);

                var _this = _possibleConstructorReturn(this, (FileUpHOC.__proto__ || Object.getPrototypeOf(FileUpHOC)).apply(this, arguments));

                _this._onAdd = _this._onAdd.bind(_this);
                _this._onUpdate = _this._onUpdate.bind(_this);
                _this._onRemove = _this._onRemove.bind(_this);
                _this._onUserAdd = _this._onUserAdd.bind(_this);
                _this._onUserRemove = _this._onUserRemove.bind(_this);

                _this._uploader = new _fileupCore2.default(_extends({
                    dropArea: {},
                    backendUrl: _this.props.backendUrl || config.backendUrl,
                    form: {
                        multiple: !!_this.props.multiple
                    }
                }, config.uploader, _this.props.uploader || {}));

                // Add uploaded files
                if (_this.props.initialFiles.length > 0) {
                    _this._onUserAdd(_this.props.initialFiles);
                }
                return _this;
            }

            _createClass(FileUpHOC, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    this._uploader.queue.on(_QueueCollection2.default.EVENT_ADD, this._onAdd);
                    this._uploader.queue.on(_QueueCollection2.default.EVENT_ITEM_STATUS, this._onUpdate);
                    this._uploader.queue.on(_QueueCollection2.default.EVENT_ITEM_PROGRESS, this._onUpdate);
                    this._uploader.queue.on(_QueueCollection2.default.EVENT_REMOVE, this._onRemove);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this._uploader.queue.off(_QueueCollection2.default.EVENT_ADD, this._onAdd);
                    this._uploader.queue.off(_QueueCollection2.default.EVENT_ITEM_STATUS, this._onUpdate);
                    this._uploader.queue.off(_QueueCollection2.default.EVENT_ITEM_PROGRESS, this._onUpdate);
                    this._uploader.queue.off(_QueueCollection2.default.EVENT_REMOVE, this._onRemove);
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2.default.createElement(WrappedComponent, _extends({}, this.props, {
                        uploader: this._uploader,
                        add: this._onUserAdd,
                        remove: this._onUserRemove
                    }));
                }
            }, {
                key: '_onAdd',
                value: function _onAdd(files) {
                    var _this2 = this;

                    files.forEach(function (file) {
                        return _this2.props.dispatch((0, _actions.add)(_this2.props.reduxStateId, file));
                    });
                }
            }, {
                key: '_onUpdate',
                value: function _onUpdate(file) {
                    this.props.dispatch((0, _actions.update)(this.props.reduxStateId, file));
                }
            }, {
                key: '_onRemove',
                value: function _onRemove(files) {
                    var _this3 = this;

                    files.forEach(function (file) {
                        return _this3.props.dispatch((0, _actions.remove)(_this3.props.reduxStateId, file));
                    });
                }
            }, {
                key: '_onUserAdd',
                value: function _onUserAdd(files) {
                    var _this4 = this;

                    var fileModels = files.map(function (item) {
                        return new _File2.default(_extends({
                            status: _File2.default.STATUS_END,
                            result: _File2.default.RESULT_SUCCESS,
                            resultHttpStatus: 200
                        }, item));
                    });

                    this._uploader.queue.add(fileModels);
                    fileModels.forEach(function (file) {
                        return _this4.props.dispatch((0, _actions.add)(_this4.props.reduxStateId, file));
                    });
                }
            }, {
                key: '_onUserRemove',
                value: function _onUserRemove(uids) {
                    uids = [].concat(uids);

                    var files = this._uploader.queue.getFiles().filter(function (file) {
                        if (uids.indexOf(file.getUid()) !== -1) {
                            return true;
                        }

                        var data = file.getResultHttpMessage();
                        return data && uids.indexOf(data.uid) !== -1;
                    });
                    if (files.length > 0) {
                        this._uploader.queue.remove(files);
                    }
                }
            }]);

            return FileUpHOC;
        }(_react2.default.Component);

        FileUpHOC.propTypes = {
            reduxStateId: _propTypes2.default.string.isRequired,
            backendUrl: _propTypes2.default.string,
            multiple: _propTypes2.default.bool,
            files: _propTypes2.default.arrayOf(_FilePropType2.default),
            initialFiles: _propTypes2.default.arrayOf(_propTypes2.default.object),
            uploader: _propTypes2.default.object,
            dispatch: _propTypes2.default.func
        };
        FileUpHOC.defaultProps = {
            initialFiles: []
        };


        FileUpHOC.WrappedComponent = WrappedComponent;

        return (0, _reactRedux.connect)(function (state, props) {
            return {
                files: (0, _fileup.getFiles)(state, props.reduxStateId)
            };
        })(FileUpHOC);
    };
};