'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getFiles = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _actions = require('../actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {
    files: {}
};

exports.default = function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case _actions.FILEUP_ADD:
        case _actions.FILEUP_UPDATE:
            return _extends({}, state, {
                files: _extends({}, state.files, _defineProperty({}, action.uploaderId, _extends({}, state.files[action.uploaderId] || {}, _defineProperty({}, action.uid, action.data))))
            });

        case _actions.FILEUP_REMOVE:
            if (state.files[action.uploaderId] && state.files[action.uploaderId][action.uid]) {
                var files = state.files[action.uploaderId];
                delete files[action.uid];

                return _extends({}, state, {
                    files: _extends({}, state.files, _defineProperty({}, action.uploaderId, files))
                });
            }
            return state;

        default:
            return state;
    }
};

var getFiles = exports.getFiles = function getFiles(state, uploaderId) {
    var files = state.fileup && state.fileup.files[uploaderId] || {};
    return Object.keys(files).map(function (key) {
        return files[key];
    });
};